# Why Bloc?

> Bloc makes it easy to separate presentation from business logic, making your code *fast, easy to test, and reusable*.

When building production-quality apps, managing state is critical.

As developers, we want to:

* know what state our application is in at any point in time;
* easily test every case to make sure our app is responding appropriately;
* record every single user interaction in our application so we can make data-driven decisions;
* work as efficiently as possible and reuse components both within our application and across applications;
* have many developers seamlessly working within a single codebase, following the same patterns and conventions;
* develop fast and reactive apps.

Bloc was designed to meet all these needs and more.

There are many state management solutions and deciding which to use can be a daunting task. There is no perfect state management solution! What's important is that you pick the one that's best for your team and your project.

Bloc was designed with three core values in mind.

* **Simple**: Easy to understand, and can be used by developers with varying skill levels;
* **Powerful**: Help make amazing, complex applications by composing them from smaller components;
* **Testable**: Easily test every aspect of your app so you can iterate with confidence.

Overall, Bloc attempts to make state changes predictable by regulating when a state change can occur, and enforcing a single way to change state throughout an app.